<?php

namespace Kitt3n\SingleSignOnForSymfonyBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files.
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/configuration.html}
 */
class Configuration implements ConfigurationInterface
{
    /**
     * {@inheritdoc}
     */
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder('single_sign_on_for_symfony');
        $rootNode = $treeBuilder->getRootNode();

        // Here you should define the parameters that are allowed to
        // configure your bundle. See the documentation linked above for
        // more information on that topic.

        $rootNode
            ->children()

                ->arrayNode('oauth')
                    ->addDefaultsIfNotSet()
                    ->children()
                        ->scalarNode('client_id')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('client_secret')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('tenant')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('redirect_uri')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('url_authorize')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('url_access_token')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('url_resource_owner_details')->isRequired()->defaultValue(null)->end()
                        ->scalarNode('scopes')->isRequired()->defaultValue(null)->end()

                    ->end()
                ->end()

                ->arrayNode('encryption')
                    ->addDefaultsIfNotSet()
                    ->children()
                        ->scalarNode('secret')->isRequired()->defaultValue(null)->end()
                    ->end()
                ->end()

                ->arrayNode('handlers')
                    ->addDefaultsIfNotSet()
                    ->children()
                        ->booleanNode('session')->isRequired()->defaultValue(true)->end()
                        ->booleanNode('cookie')->isRequired()->defaultValue(true)->end()
                    ->end()
                ->end()

            ->end()
            ;

        return $treeBuilder;
    }
}
